--- /home/topic/kaffe/libraries/javalib/java/lang/reflect/Array.java	Fri Apr 26 02:33:46 2002
+++ libraries/javalib/java/lang/reflect/Array.java	Sun Apr 28 18:10:43 2002
@@ -17,25 +17,178 @@
 private Array() {
 }
     
-native public static Object get(Object array, int index) throws IllegalArgumentException, ArrayIndexOutOfBoundsException;
+private static void checkComponentType(Class componentType) {
+	if (componentType == null) {
+		throw new NullPointerException();
+	}
+	if (componentType == Void.TYPE) {
+		throw new IllegalArgumentException();
+	}
+}
 
-native public static boolean getBoolean(Object array, int index) throws IllegalArgumentException, ArrayIndexOutOfBoundsException;
+public static Object get(Object array, int index) throws IllegalArgumentException, ArrayIndexOutOfBoundsException {
+	if (array instanceof Object[]) {
+		return (((Object[])array)[index]);
+	}
+	else if (array instanceof boolean[]) {
+		return new Boolean(((boolean[])array)[index]);
+	}
+	else if (array instanceof byte[]) {
+		return new Byte(((byte[])array)[index]);
+	}
+	else if (array instanceof short[]) {
+		return new Short(((short[])array)[index]);
+	}
+	else if (array instanceof char[]) {
+		return new Character(((char[])array)[index]);
+	}
+	else if (array instanceof int[]) {
+		return new Integer(((int[])array)[index]);
+	}
+	else if (array instanceof long[]) {
+		return new Long(((long[])array)[index]);
+	}
+	else if (array instanceof float[]) {
+		return new Float(((float[])array)[index]);
+	}
+	else if (array instanceof double[]) {
+		return new Double(((double[])array)[index]);
+	}
+	else {
+		throw new IllegalArgumentException();
+	}
+}
+
+public static boolean getBoolean(Object array, int index) throws IllegalArgumentException, ArrayIndexOutOfBoundsException {
+	if (array instanceof boolean[]) {
+		return (((boolean[])array)[index]);
+	}
+	else {
+		throw new IllegalArgumentException();
+	}
+}
 
-native public static byte getByte(Object array, int index) throws IllegalArgumentException, ArrayIndexOutOfBoundsException;
+public static byte getByte(Object array, int index) throws IllegalArgumentException, ArrayIndexOutOfBoundsException {
+	if (array instanceof byte[]) {
+		return (((byte[])array)[index]);
+	}
+	else {
+		throw new IllegalArgumentException();
+	}
+}
 
-native public static char getChar(Object array, int index) throws IllegalArgumentException, ArrayIndexOutOfBoundsException;
+public static char getChar(Object array, int index) throws IllegalArgumentException, ArrayIndexOutOfBoundsException {
+	if (array instanceof char[]) {
+		return (((char[])array)[index]);
+	}
+	else {
+		throw new IllegalArgumentException();
+	}
+}
 
-native public static double getDouble(Object array, int index) throws IllegalArgumentException, ArrayIndexOutOfBoundsException;
+public static double getDouble(Object array, int index) throws IllegalArgumentException, ArrayIndexOutOfBoundsException {
+	if (array instanceof double[]) {
+		return (((double[])array)[index]);
+	}
+	else if (array instanceof byte[]) {
+		return (((byte[])array)[index]);
+	}
+	else if (array instanceof short[]) {
+		return (((short[])array)[index]);
+	}
+	else if (array instanceof char[]) {
+		return (((char[])array)[index]);
+	}
+	else if (array instanceof int[]) {
+		return (((int[])array)[index]);
+	}
+	else if (array instanceof long[]) {
+		return (((long[])array)[index]);
+	}
+	else if (array instanceof float[]) {
+		return (((float[])array)[index]);
+	}
+	else {
+		throw new IllegalArgumentException();
+	}
+}
 
-native public static float getFloat(Object array, int index) throws IllegalArgumentException, ArrayIndexOutOfBoundsException;
+public static float getFloat(Object array, int index) throws IllegalArgumentException, ArrayIndexOutOfBoundsException {
+	if (array instanceof float[]) {
+		return (((float[])array)[index]);
+	}
+	else if (array instanceof byte[]) {
+		return (((byte[])array)[index]);
+	}
+	else if (array instanceof short[]) {
+		return (((short[])array)[index]);
+	}
+	else if (array instanceof char[]) {
+		return (((char[])array)[index]);
+	}
+	else if (array instanceof int[]) {
+		return (((int[])array)[index]);
+	}
+	else if (array instanceof long[]) {
+		return (((long[])array)[index]);
+	}
+	else {
+		throw new IllegalArgumentException();
+	}
+}
 
-native public static int getInt(Object array, int index) throws IllegalArgumentException, ArrayIndexOutOfBoundsException;
+public static int getInt(Object array, int index) throws IllegalArgumentException, ArrayIndexOutOfBoundsException {
+	if (array instanceof int[]) {
+		return (((int[])array)[index]);
+	}
+	else if (array instanceof byte[]) {
+		return (((byte[])array)[index]);
+	}
+	else if (array instanceof short[]) {
+		return (((short[])array)[index]);
+	}
+	else if (array instanceof char[]) {
+		return (((char[])array)[index]);
+	}
+	else {
+		throw new IllegalArgumentException();
+	}
+}
 
-native public static int getLength(Object array) throws IllegalArgumentException;
+public static long getLong(Object array, int index) throws IllegalArgumentException, ArrayIndexOutOfBoundsException {
+	if (array instanceof long[]) {
+		return (((long[])array)[index]);
+	}
+	else if (array instanceof byte[]) {
+		return (((byte[])array)[index]);
+	}
+	else if (array instanceof short[]) {
+		return (((short[])array)[index]);
+	}
+	else if (array instanceof char[]) {
+		return (((char[])array)[index]);
+	}
+	else if (array instanceof int[]) {
+		return (((int[])array)[index]);
+	}
+	else {
+		throw new IllegalArgumentException();
+	}
+}
 
-native public static long getLong(Object array, int index) throws IllegalArgumentException, ArrayIndexOutOfBoundsException;
+public static short getShort(Object array, int index) throws IllegalArgumentException, ArrayIndexOutOfBoundsException {
+	if (array instanceof short[]) {
+		return (((short[])array)[index]);
+	}
+	else if (array instanceof byte[]) {
+		return (((byte[])array)[index]);
+	}
+	else {
+		throw new IllegalArgumentException();
+	}
+}
 
-native public static short getShort(Object array, int index) throws IllegalArgumentException, ArrayIndexOutOfBoundsException;
+native public static int getLength(Object array) throws IllegalArgumentException;
 
 native private static Object multiNewArray(Class componentType, int dimensions[]);
 
@@ -43,52 +196,236 @@
 
 public static Object newInstance(Class componentType, int len) throws NegativeArraySizeException
 {
-	if (componentType == null) {
-		throw new NullPointerException();
-	}
-	if (componentType == Void.TYPE) {
-		throw new IllegalArgumentException();
-	}
+	checkComponentType(componentType);
+
 	if (len < 0) {
 		throw new NegativeArraySizeException();
 	}
-	return (newArray(componentType, len));
+
+	if (!componentType.isPrimitive()) {
+		return (newArray(componentType, len));
+	}
+	else if (componentType == Boolean.TYPE) {
+		return (new boolean[len]);
+	}
+	else if (componentType == Byte.TYPE) {
+		return (new byte[len]);
+	}
+	else if (componentType == Short.TYPE) {
+		return (new short[len]);
+	}
+	else if (componentType == Character.TYPE) {
+		return (new char[len]);
+	}
+	else if (componentType == Integer.TYPE) {
+		return (new int[len]);
+	}
+	else if (componentType == Long.TYPE) {
+		return (new long[len]);
+	}
+	else if (componentType == Float.TYPE) {
+		return (new float[len]);
+	}
+	else if (componentType == Double.TYPE) {
+		return (new double[len]);
+	}
+	else {
+		throw new Error();
+	}
 }
 
 public static Object newInstance(Class componentType, int dimensions[]) throws IllegalArgumentException, NegativeArraySizeException
 {
-	if (componentType == null) {
-		throw new NullPointerException();
-	}
+	checkComponentType(componentType);
+
 	if (dimensions.length == 0 || dimensions.length > 255) {
 		throw new IllegalArgumentException();
 	}
-	if (componentType == Void.TYPE) {
-		throw new IllegalArgumentException();
-	}
 	for (int i = 0; i < dimensions.length; i++) {
 		if (dimensions[i] < 0) {
 			throw new NegativeArraySizeException();
 		}
 	}
-	return (multiNewArray(componentType, dimensions));
+
+	return (newInstanceInternal(componentType, dimensions, 0));
 }
 
-native public static void set(Object array, int index, Object value) throws IllegalArgumentException, ArrayIndexOutOfBoundsException;
+private static Object newInstanceInternal(Class componentType, int[] dimensions, int offset) {
+	Object obj = newInstance(componentType, dimensions[offset]);
+	offset++;
+	if (offset < dimensions.length) {
+		Object[] array = (Object[])obj;
+		componentType = componentType.getComponentType();
+		for (int i = dimensions[offset]; i >= 0; i--) {
+			array[i] = newInstanceInternal(componentType, dimensions, offset);
+		}
+	}
+	return (obj);
+}
 
-native public static void setBoolean(Object array, int index, boolean z) throws IllegalArgumentException, ArrayIndexOutOfBoundsException;
+public static void set(Object array, int index, Object value) throws IllegalArgumentException, ArrayIndexOutOfBoundsException {
+	if (array instanceof Object[]) {
+		try {
+			((Object[])array)[index] = value;
+		}
+		catch (ArrayStoreException _) {
+			throw new IllegalArgumentException();
+		}
+	}
+	else if (array instanceof boolean[] && value instanceof Boolean) {
+		((boolean[])array)[index] = ((Boolean)value).booleanValue();
+	}
+	else if (array instanceof byte[] && value instanceof Byte) {
+		((byte[])array)[index] = ((Byte)value).byteValue();
+	}
+	else if (array instanceof short[] && value instanceof Short) {
+		((short[])array)[index] = ((Short)value).shortValue();
+	}
+	else if (array instanceof char[] && value instanceof Character) {
+		((char[])array)[index] = ((Character)value).charValue();
+	}
+	else if (array instanceof int[] && value instanceof Integer) {
+		((int[])array)[index] = ((Integer)value).intValue();
+	}
+	else if (array instanceof long[] && value instanceof Long) {
+		((long[])array)[index] = ((Long)value).longValue();
+	}
+	else if (array instanceof float[] && value instanceof Float) {
+		((float[])array)[index] = ((Float)value).floatValue();
+	}
+	else if (array instanceof double[] && value instanceof Double) {
+		((double[])array)[index] = ((Double)value).doubleValue();
+	}
+	else {
+		throw new IllegalArgumentException();
+	}
+}
+public static void setBoolean(Object array, int index, boolean z) throws IllegalArgumentException, ArrayIndexOutOfBoundsException {
+	if (array instanceof boolean[]) {
+		((boolean[])array)[index] = z;
+	}
+	else {
+		throw new IllegalArgumentException();
+	}
+}
 
-native public static void setByte(Object array, int index, byte b) throws IllegalArgumentException, ArrayIndexOutOfBoundsException;
+public static void setByte(Object array, int index, byte b) throws IllegalArgumentException, ArrayIndexOutOfBoundsException {
+	if (array instanceof byte[]) {
+		((byte[])array)[index] = b;
+	}
+	else if (array instanceof short[]) {
+		((short[])array) [index] = b;
+	}
+       	else if (array instanceof int[]) {
+		((int[])array) [index] = b;
+	}
+	else if (array instanceof long[]) {
+		((long[])array) [index] = b;
+	}
+	else if (array instanceof float[]) {
+		((float[])array) [index] = b;
+	}
+	else if (array instanceof double[]) {
+		((double[])array) [index] = b;
+	}
+	else {
+		throw new IllegalArgumentException();
+	}
+}
 
-native public static void setChar(Object array, int index, char c) throws IllegalArgumentException, ArrayIndexOutOfBoundsException;
+public static void setChar(Object array, int index, char c) throws IllegalArgumentException, ArrayIndexOutOfBoundsException {
+	if (array instanceof char[]) {
+		((char[])array)[index] = c;
+	}
+	else if (array instanceof int[]) {
+		((int[])array) [index] = c;
+	}
+	else if (array instanceof long[]) {
+		((long[])array) [index] = c;
+	}
+	else if (array instanceof float[]) {
+		((float[])array) [index] = c;
+	}
+	else if (array instanceof double[]) {
+		((double[])array) [index] = c;
+	}
+	else {
+		throw new IllegalArgumentException();
+	}
+}
 
-native public static void setDouble(Object array, int index, double d) throws IllegalArgumentException, ArrayIndexOutOfBoundsException;
+public static void setDouble(Object array, int index, double d) throws IllegalArgumentException, ArrayIndexOutOfBoundsException {
+	if (array instanceof double[]) {
+		((double[])array)[index] = d;
+	}
+	else {
+		throw new IllegalArgumentException();
+	}
+}
 
-native public static void setFloat(Object array, int index, float f) throws IllegalArgumentException, ArrayIndexOutOfBoundsException;
+public static void setFloat(Object array, int index, float f) throws IllegalArgumentException, ArrayIndexOutOfBoundsException {
+	if (array instanceof float[]) {
+		((float[])array)[index] = f;
+	}
+	else if (array instanceof double[]) {
+		((double[])array) [index] = f;
+	}
+	else {
+		throw new IllegalArgumentException();
+	}
+}
 
-native public static void setInt(Object array, int index, int i) throws IllegalArgumentException, ArrayIndexOutOfBoundsException;
+public static void setInt(Object array, int index, int i) throws IllegalArgumentException, ArrayIndexOutOfBoundsException {
+	if (array instanceof int[]) {
+		((int[])array)[index] = i;
+	}
+	else if (array instanceof long[]) {
+		((long[])array) [index] = i;
+	}
+	else if (array instanceof float[]) {
+		((float[])array) [index] = i;
+	}
+	else if (array instanceof double[]) {
+		((double[])array) [index] = i;
+	}
+	else {
+		throw new IllegalArgumentException();
+	}
+}
 
-native public static void setLong(Object array, int index, long l) throws IllegalArgumentException, ArrayIndexOutOfBoundsException;
+public static void setLong(Object array, int index, long l) throws IllegalArgumentException, ArrayIndexOutOfBoundsException {
+	if (array instanceof long[]) {
+		((long[])array)[index] = l;
+	}
+	else if (array instanceof float[]) {
+		((float[])array) [index] = l;
+	}
+	else if (array instanceof double[]) {
+		((double[])array) [index] = l;
+	}
+	else {
+		throw new IllegalArgumentException();
+	}
+}
 
-native public static void setShort(Object array, int index, short s) throws IllegalArgumentException, ArrayIndexOutOfBoundsException;
+public static void setShort(Object array, int index, short s) throws IllegalArgumentException, ArrayIndexOutOfBoundsException {
+	if (array instanceof short[]) {
+		((short[])array)[index] = s;
+	}
+	else if (array instanceof int[]) {
+		((int[])array) [index] = s;
+	}
+	else if (array instanceof long[]) {
+		((long[])array) [index] = s;
+	}
+	else if (array instanceof float[]) {
+		((float[])array) [index] = s;
+	}
+	else if (array instanceof double[]) {
+		((double[])array) [index] = s;
+	}
+	else {
+		throw new IllegalArgumentException();
+	}
+}
 }
--- /home/topic/kaffe/libraries/javalib/java/lang/reflect/Constructor.java	Fri Apr 26 02:33:46 2002
+++ libraries/javalib/java/lang/reflect/Constructor.java	Mon Apr 29 01:18:35 2002
@@ -80,7 +80,15 @@
 	return (clazz.getName().hashCode());
 }
 
-native public Object newInstance(Object initargs[]) throws InstantiationException, IllegalAccessException, IllegalArgumentException, InvocationTargetException;
+public Object newInstance(Object initargs[]) throws InstantiationException, IllegalAccessException, IllegalArgumentException, InvocationTargetException {
+	Method meth = new Method(clazz,
+				 slot,
+				 "<init>",
+				 clazz,
+				 parameterTypes,
+				 exceptionTypes);
+	return (meth.invoke(null, initargs));
+}
 
 public String toString()
 	{
--- /home/topic/kaffe/libraries/javalib/java/lang/reflect/Field.java	Fri Apr 26 02:33:46 2002
+++ libraries/javalib/java/lang/reflect/Field.java	Sun Apr 28 20:07:55 2002
@@ -43,63 +43,351 @@
 	return (false);
 }
 
-native public Object get(Object obj) throws IllegalArgumentException, IllegalAccessException;
+public Object get(Object obj) throws IllegalArgumentException, IllegalAccessException {
+	if (type == Double.TYPE) {
+		return (new Double(getDouble0(obj)));
+	}
+	else if (type == Float.TYPE) {
+		return (new Float(getFloat0(obj)));
+	}
+	else if (type == Long.TYPE) {
+		return (new Long(getLong0(obj)));
+	}
+	else if (type == Integer.TYPE) {
+		return (new Integer(getInt0(obj)));
+	}
+	else if (type == Short.TYPE) {
+		return (new Short(getShort0(obj)));
+	}
+	else if (type == Byte.TYPE) {
+		return (new Byte(getByte0(obj)));
+	}
+	else if (type == Character.TYPE) {
+		return (new Character(getChar0(obj)));
+	}
+	else {
+		return (getObject0(obj));
+	}
+}
 
-native public boolean getBoolean(Object obj) throws IllegalArgumentException, IllegalAccessException;
+public boolean getBoolean(Object obj) throws IllegalArgumentException, IllegalAccessException {
+	if (type == Boolean.TYPE) {
+		return (getBoolean0(obj));
+	}
+	else {
+		throw new IllegalArgumentException();
+	}
+}
 
-native public byte getByte(Object obj) throws IllegalArgumentException, IllegalAccessException;
+public byte getByte(Object obj) throws IllegalArgumentException, IllegalAccessException {
+	if (type == Byte.TYPE) {
+		return (getByte0(obj));
+	}
+	else {
+		throw new IllegalArgumentException();
+	}
+}
 
-native public char getChar(Object obj) throws IllegalArgumentException, IllegalAccessException;
+public char getChar(Object obj) throws IllegalArgumentException, IllegalAccessException {
+	if (type == Character.TYPE) {
+		return (getChar0(obj));
+	}
+	else {
+		throw new IllegalArgumentException();
+	}
+}
 
-public Class getDeclaringClass()
-	{
-	return (clazz);
+public double getDouble(Object obj) throws IllegalArgumentException, IllegalAccessException {
+	if (type == Double.TYPE) {
+		return (getDouble0(obj));
+	}
+	else if (type == Float.TYPE) {
+		return ((double)getFloat0(obj));
+	}
+	else if (type == Long.TYPE) {
+		return ((double)getLong0(obj));
+	}
+	else if (type == Integer.TYPE) {
+		return ((double)getInt0(obj));
+	}
+	else if (type == Short.TYPE) {
+		return ((double)getShort0(obj));
+	}
+	else if (type == Byte.TYPE) {
+		return ((double)getByte0(obj));
+	}
+	else if (type == Character.TYPE) {
+		return ((double)getChar0(obj));
+	}
+	else {
+		throw new IllegalArgumentException();
+	}
 }
 
-native public double getDouble(Object obj) throws IllegalArgumentException, IllegalAccessException;
+public float getFloat(Object obj) throws IllegalArgumentException, IllegalAccessException {
+	if (type == Float.TYPE) {
+		return (getFloat0(obj));
+	}
+	else if (type == Long.TYPE) {
+		return ((float)getLong0(obj));
+	}
+	else if (type == Integer.TYPE) {
+		return ((float)getInt0(obj));
+	}
+	else if (type == Short.TYPE) {
+		return ((float)getShort0(obj));
+	}
+	else if (type == Byte.TYPE) {
+		return ((float)getByte0(obj));
+	}
+	else if (type == Character.TYPE) {
+		return ((float)getChar0(obj));
+	}
+	else {
+		throw new IllegalArgumentException();
+	}
+}
 
-native public float getFloat(Object obj) throws IllegalArgumentException, IllegalAccessException;
+public int getInt(Object obj) throws IllegalArgumentException, IllegalAccessException {
+	if (type == Integer.TYPE) {
+		return (getInt0(obj));
+	}
+	else if (type == Short.TYPE) {
+		return ((int)getShort0(obj));
+	}
+	else if (type == Byte.TYPE) {
+		return ((int)getByte0(obj));
+	}
+	else if (type == Character.TYPE) {
+		return ((int)getChar0(obj));
+	}
+	else {
+		throw new IllegalArgumentException();
+	}
+}
 
-native public int getInt(Object obj) throws IllegalArgumentException, IllegalAccessException;
+public long getLong(Object obj) throws IllegalArgumentException, IllegalAccessException {
+	if (type == Long.TYPE) {
+		return (getLong0(obj));
+	}
+	else if (type == Integer.TYPE) {
+		return ((long)getInt0(obj));
+	}
+	else if (type == Short.TYPE) {
+		return ((long)getShort0(obj));
+	}
+	else if (type == Byte.TYPE) {
+		return ((long)getByte0(obj));
+	}
+	else if (type == Character.TYPE) {
+		return ((long)getChar0(obj));
+	}
+	else {
+		throw new IllegalArgumentException();
+	}
+}
 
-native public long getLong(Object obj) throws IllegalArgumentException, IllegalAccessException;
+public short getShort(Object obj) throws IllegalArgumentException, IllegalAccessException {
+	if (type == Short.TYPE) {
+		return (getShort0(obj));
+	}
+	else if (type == Integer.TYPE) {
+		return ((short)getInt0(obj));
+	}
+	else if (type == Long.TYPE) {
+		return ((short)getLong0(obj));
+	}
+	else if (type == Float.TYPE) {
+		return ((short)getFloat0(obj));
+	}
+	else if (type == Double.TYPE) {
+		return ((short)getDouble0(obj));
+	}
+	else {
+		throw new IllegalArgumentException();
+	}
+}
 
-native public int getModifiers();
+public void set(Object obj, Object value) throws IllegalArgumentException, IllegalAccessException {
+	if (type == Boolean.TYPE) {
+		setBoolean0(obj, ((Boolean)value).booleanValue());
+	}
+	else if (type == Byte.TYPE) {
+		setByte0(obj, ((Byte)value).byteValue());
+	}
+	else if (type == Short.TYPE) {
+		setShort0(obj, ((Short)value).shortValue());
+	}
+	else if (type == Character.TYPE) {
+		setChar0(obj, ((Character)value).charValue());
+	}
+	else if (type == Integer.TYPE) {
+		setInt0(obj, ((Integer)value).intValue());
+	}
+	else if (type == Long.TYPE) {
+		setLong0(obj, ((Long)value).longValue());
+	}
+	else if (type == Float.TYPE) {
+		setFloat0(obj, ((Float)value).floatValue());
+	}
+	else if (type == Double.TYPE) {
+		setDouble0(obj, ((Double)value).doubleValue());
+	}
+	else {
+		setObject0(obj, value);
+	}
+}
 
-public String getName()
-	{
-	return (name);
+public void setBoolean(Object obj, boolean z) throws IllegalArgumentException, IllegalAccessException {
+	if (type == Boolean.TYPE) {
+		setBoolean0(obj, z);
+	}
+	else {
+		throw new IllegalArgumentException();
+	}
 }
 
-native public short getShort(Object obj) throws IllegalArgumentException, IllegalAccessException;
+public void setByte(Object obj, byte b) throws IllegalArgumentException, IllegalAccessException {
+	if (type == Byte.TYPE) {
+		setByte0(obj, b);
+	}
+	else if (type == Short.TYPE) {
+		setShort0(obj, (short)b);
+	}
+	else if (type == Integer.TYPE) {
+		setInt0(obj, (int)b);
+	}
+	else if (type == Long.TYPE) {
+		setLong0(obj, (long)b);
+	}
+	else if (type == Float.TYPE) {
+		setFloat0(obj, (float)b);
+	}
+	else if (type == Double.TYPE) {
+		setDouble0(obj, (double)b);
+	}
+	else {
+		throw new IllegalArgumentException();
+	}
+}
 
-public Class getType()
-	{
-	return (type);
+public void setChar(Object obj, char c) throws IllegalArgumentException, IllegalAccessException {
+	if (type == Character.TYPE) {
+		setChar0(obj, c);
+	}
+	else if (type == Integer.TYPE) {
+		setInt0(obj, (int)c);
+	}
+	else if (type == Long.TYPE) {
+		setLong0(obj, (long)c);
+	}
+	else if (type == Float.TYPE) {
+		setFloat0(obj, (float)c);
+	}
+	else if (type == Double.TYPE) {
+		setDouble0(obj, (double)c);
+	}
+	else {
+		throw new IllegalArgumentException();
+	}
 }
 
-public int hashCode()
-	{
-	return (clazz.getName().hashCode() ^ name.hashCode());
+public void setDouble(Object obj, double d) throws IllegalArgumentException, IllegalAccessException {
+	if (type == Double.TYPE) {
+		setDouble0(obj, d);
+	}
+	else {
+		throw new IllegalArgumentException();
+	}
 }
 
-native public void set(Object obj, Object value) throws IllegalArgumentException, IllegalAccessException;
+public void setFloat(Object obj, float f) throws IllegalArgumentException, IllegalAccessException {
+	if (type == Float.TYPE) {
+		setFloat0(obj, f);
+	}
+	else if (type == Double.TYPE) {
+		setDouble0(obj, (double)f);
+	}
+	else {
+		throw new IllegalArgumentException();
+	}
+}
 
-native public void setBoolean(Object obj, boolean z) throws IllegalArgumentException, IllegalAccessException;
+public void setInt(Object obj, int i) throws IllegalArgumentException, IllegalAccessException {
+	if (type == Integer.TYPE) {
+		setInt0(obj, i);
+	}
+	else if (type == Long.TYPE) {
+		setLong0(obj, (long)i);
+	}
+	else if (type == Float.TYPE) {
+		setFloat0(obj, (float)i);
+	}
+	else if (type == Double.TYPE) {
+		setDouble0(obj, (double)i);
+	}
+	else {
+		throw new IllegalArgumentException();
+	}
+}
 
-native public void setByte(Object obj, byte b) throws IllegalArgumentException, IllegalAccessException;
+public void setLong(Object obj, long l) throws IllegalArgumentException, IllegalAccessException {
+	if (type == Long.TYPE) {
+		setLong0(obj, l);
+	}
+	else if (type == Float.TYPE) {
+		setFloat0(obj, (float)l);
+	}
+	else if (type == Double.TYPE) {
+		setDouble0(obj, (double)l);
+	}
+	else {
+		throw new IllegalArgumentException();
+	}
+}
 
-native public void setChar(Object obj, char c) throws IllegalArgumentException, IllegalAccessException;
+public void setShort(Object obj, short s) throws IllegalArgumentException, IllegalAccessException {
+	if (type == Short.TYPE) {
+		setShort0(obj, s);
+	}
+	else if (type == Integer.TYPE) {
+		setInt0(obj, (int)s);
+	}
+	else if (type == Long.TYPE) {
+		setLong0(obj, (long)s);
+	}
+	else if (type == Float.TYPE) {
+		setFloat0(obj, (float)s);
+	}
+	else if (type == Double.TYPE) {
+		setDouble0(obj, (double)s);
+	}
+	else {
+		throw new IllegalArgumentException();
+	}
+}
 
-native public void setDouble(Object obj, double d) throws IllegalArgumentException, IllegalAccessException;
+public Class getDeclaringClass()
+	{
+	return (clazz);
+}
 
-native public void setFloat(Object obj, float f) throws IllegalArgumentException, IllegalAccessException;
+native public int getModifiers();
 
-native public void setInt(Object obj, int i) throws IllegalArgumentException, IllegalAccessException;
+public String getName()
+	{
+	return (name);
+}
 
-native public void setLong(Object obj, long l) throws IllegalArgumentException, IllegalAccessException;
+public Class getType()
+	{
+	return (type);
+}
 
-native public void setShort(Object obj, short s) throws IllegalArgumentException, IllegalAccessException;
+public int hashCode()
+	{
+	return (clazz.getName().hashCode() ^ name.hashCode());
+}
 
 public String toString()
 	{
@@ -124,4 +412,24 @@
 
 	return (str.toString());
 }
+
+native private boolean getBoolean0(Object obj);
+native private byte getByte0(Object obj);
+native private char getChar0(Object obj);
+native private short getShort0(Object obj);
+native private int getInt0(Object obj);
+native private long getLong0(Object obj);
+native private float getFloat0(Object obj);
+native private double getDouble0(Object obj);
+native private Object getObject0(Object obj);
+
+native private void setBoolean0(Object obj, boolean v);
+native private void setByte0(Object obj, byte v);
+native private void setChar0(Object obj, char v);
+native private void setShort0(Object obj, short v);
+native private void setInt0(Object obj, int v);
+native private void setLong0(Object obj, long v);
+native private void setFloat0(Object obj, float v);
+native private void setDouble0(Object obj, double v);
+native private void setObject0(Object obj, Object v);
 }
--- /home/topic/kaffe/libraries/javalib/java/lang/reflect/Method.java	Fri Apr 26 02:33:46 2002
+++ libraries/javalib/java/lang/reflect/Method.java	Mon Apr 29 01:17:04 2002
@@ -18,6 +18,7 @@
     implements Member
 {
 
+static private final Object[] nullArgs = new Object[0];
 private Class clazz;
 private int slot;
 private String name;
@@ -25,9 +26,27 @@
 private Class[] parameterTypes;
 private Class[] exceptionTypes;
 
+static {
+	init0();
+}
+
+native private static void init0();
+
 private Method() {
 }
 
+/* used by Constructor.newInstance */
+Method(Class clazz, int slot, String name, Class returnType,
+       Class [] parameterTypes, Class [] exceptionTypes)
+{
+	this.clazz = clazz;
+	this.slot = slot;
+	this.name = name;
+	this.returnType = returnType;
+	this.parameterTypes = parameterTypes;
+	this.exceptionTypes = exceptionTypes;
+}
+
 public boolean equals(Object obj) {
 	// Catch the simple case where they're really the same
 	if (this == obj) {
@@ -87,7 +106,11 @@
 	IllegalArgumentException,
 	InvocationTargetException {
 
-	if (obj == null && !Modifier.isStatic(getModifiers())) {
+	if (args == null) {
+		args = nullArgs;
+	}
+
+	if (obj == null && !"<init>".equals(name) && !Modifier.isStatic(getModifiers())) {
 		throw new NullPointerException("Null object pointer");
 	}
 
@@ -95,15 +118,148 @@
 		throw new IllegalArgumentException("Object type doesn't match method's class");
 	}
 
-	int len = (args == null ? 0 : args.length);
-	if (len != getParameterTypes().length) {
+	if (args.length != getParameterTypes().length) {
 		throw new IllegalArgumentException("wrong number of arguments");
 	}
 
-	return invoke0(obj, args);
+	/* Process arguments to get them 'correct' */
+	for (int i = 0; i < args.length; i++) {
+		Class pt = parameterTypes[i];
+		Object arg = args[i];
+		if (arg == null || pt.isAssignableFrom(arg.getClass())) {
+			/* Arg okay */
+		}
+		else if (pt.isPrimitive()) {
+			/* Might need fixup */
+			if (pt == Boolean.TYPE) {
+				if (arg instanceof Boolean) {
+				}
+				else {
+					throw new IllegalAccessException();
+				}
+			}
+			else if (pt == Byte.TYPE) {
+				if (arg instanceof Byte) {
+				}
+				else {
+					throw new IllegalAccessException();
+				}
+			}
+			else if (pt == Short.TYPE) {
+				if (arg instanceof Short) {
+				}
+				else if (arg instanceof Byte) {
+					args[i] = new Short((short)((Byte)arg).byteValue());
+				}
+				else {
+					throw new IllegalAccessException();
+				}
+			}
+			else if (pt == Character.TYPE) {
+				if (arg instanceof Character) {
+				}
+				else if (arg instanceof Byte) {
+					args[i] = new Character((char)((Byte)arg).byteValue());
+				}
+				else {
+					throw new IllegalAccessException();
+				}
+			}
+			else if (pt == Integer.TYPE) {
+				if (arg instanceof Integer) {
+				}
+				else if (arg instanceof Short) {
+					args[i] = new Integer((int)((Short)arg).shortValue());
+				}
+				else if (arg instanceof Character) {
+					args[i] = new Integer((int)((Character)arg).charValue());
+				}
+				else if (arg instanceof Byte) {
+					args[i] = new Integer((int)((Byte)arg).byteValue());
+				}
+				else {
+					throw new IllegalAccessException();
+				}
+			}
+			else if (pt == Long.TYPE) {
+				if (arg instanceof Long) {
+				}
+				if (arg instanceof Integer) {
+					args[i] = new Long((long)((Integer)arg).intValue());
+				}
+				else if (arg instanceof Short) {
+					args[i] = new Long((long)((Short)arg).shortValue());
+				}
+				else if (arg instanceof Character) {
+					args[i] = new Long((long)((Character)arg).charValue());
+				}
+				else if (arg instanceof Byte) {
+					args[i] = new Long((long)((Byte)arg).byteValue());
+				}
+				else {
+					throw new IllegalAccessException();
+				}
+			}
+			else if (pt == Float.TYPE) {
+				if (arg instanceof Float) {
+				}
+				else if (arg instanceof Long) {
+					args[i] = new Float((float)((Long)arg).longValue());
+				}
+				if (arg instanceof Integer) {
+					args[i] = new Float((float)((Integer)arg).intValue());
+				}
+				else if (arg instanceof Short) {
+					args[i] = new Float((float)((Short)arg).shortValue());
+				}
+				else if (arg instanceof Character) {
+					args[i] = new Float((float)((Character)arg).charValue());
+				}
+				else if (arg instanceof Byte) {
+					args[i] = new Float((float)((Byte)arg).byteValue());
+				}
+				else {
+					throw new IllegalAccessException();
+				}
+			}
+			else if (pt == Double.TYPE) {
+				if (arg instanceof Float) {
+				}
+				else if (arg instanceof Float) {
+					args[i] = new Double((double)((Float)arg).floatValue());
+				}
+				else if (arg instanceof Long) {
+					args[i] = new Double((double)((Long)arg).longValue());
+				}
+				if (arg instanceof Integer) {
+					args[i] = new Double((double)((Integer)arg).intValue());
+				}
+				else if (arg instanceof Short) {
+					args[i] = new Double((double)((Short)arg).shortValue());
+				}
+				else if (arg instanceof Character) {
+					args[i] = new Double((double)((Character)arg).charValue());
+				}
+				else if (arg instanceof Byte) {
+					args[i] = new Double((double)((Byte)arg).byteValue());
+				}
+				else {
+					throw new IllegalAccessException();
+				}
+			}
+			else {
+				throw new Error("cannot happen");
+			}
+		}
+		else {
+			throw new IllegalAccessException("incompatible argument");
+		}
+	}
+
+	return (invoke0(obj, args));
 }
 
-native public Object invoke0(Object obj, Object args[]) throws IllegalAccessException, IllegalArgumentException, InvocationTargetException;
+native Object invoke0(Object obj, Object args[]) throws IllegalAccessException, IllegalArgumentException, InvocationTargetException;
 
 public String toString() {
 	StringBuffer str = new StringBuffer();
--- /home/topic/kaffe/libraries/clib/native/Array.c	Fri Apr 26 02:33:14 2002
+++ libraries/clib/native/Array.c	Sun Apr 28 18:52:22 2002
@@ -39,720 +39,6 @@
 }
 
 struct Hjava_lang_Object*
-java_lang_reflect_Array_get(struct Hjava_lang_Object* obj, jint elem)
-{
-	Hjava_lang_Class *clazz;
-
-	if (!CLASS_IS_ARRAY(OBJECT_CLASS(obj)))
-		SignalError("java.lang.IllegalArgumentException", "");
-
-	clazz = CLASS_ELEMENT_TYPE(OBJECT_CLASS(obj));
-
-	if ( clazz == intClass ) {
-		HArrayOfInt *arr = (HArrayOfInt *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-
-		return execute_java_constructor(0, 0, javaLangIntegerClass,
-		    "(I)V", (jint)unhand_array(arr)->body[elem]);
-	}
-	else if ( clazz == shortClass ) {
-		HArrayOfShort *arr = (HArrayOfShort *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-
-		return execute_java_constructor(0, 0, javaLangShortClass,
-		    "(S)V", (jint)unhand_array(arr)->body[elem]);
-	}
-	else if ( clazz == longClass ) {
-		HArrayOfLong *arr = (HArrayOfLong *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-
-		return execute_java_constructor(0, 0, javaLangLongClass,
-		    "(J)V", (jlong)unhand_array(arr)->body[elem]);
-	}
-	else if ( clazz == byteClass ) {
-		HArrayOfByte *arr = (HArrayOfByte *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-
-		return execute_java_constructor(0, 0, javaLangByteClass,
-		    "(B)V", (jint)unhand_array(arr)->body[elem]);
-	}
-	else if ( clazz == booleanClass ) {
-		HArrayOfBoolean *arr = (HArrayOfBoolean *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-
-		return execute_java_constructor(0, 0, javaLangBooleanClass,
-		   "(Z)V", (jint)unhand_array(arr)->body[elem]);
-	}
-	else if ( clazz == charClass ) {
-		HArrayOfChar *arr = (HArrayOfChar *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-
-		return execute_java_constructor(0, 0, javaLangCharacterClass,
-		    "(C)V", (jint)unhand_array(arr)->body[elem]);
-	}
-	else if ( clazz == floatClass ) {
-		HArrayOfFloat *arr = (HArrayOfFloat *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-
-		return execute_java_constructor(0, 0, javaLangFloatClass,
-		    "(F)V", (jfloat)unhand_array(arr)->body[elem]);
-	}
-	else if ( clazz == doubleClass ) {
-		HArrayOfDouble *arr = (HArrayOfDouble *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-
-		return execute_java_constructor(0, 0, javaLangDoubleClass,
-		    "(D)V", (jdouble)unhand_array(arr)->body[elem]);
-	}
-	else {
-		/* If clazz isn't one of the above then it's either a
-		 * reference or unresolved (and so a reference).
-		 */
-
-		HArrayOfObject *arr = (HArrayOfObject *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-
-		return unhand_array(arr)->body[elem];
-	}
-}
-
-jbool
-java_lang_reflect_Array_getBoolean(struct Hjava_lang_Object* obj, jint elem)
-{
-	Hjava_lang_Class *clazz;
-
-	if (!CLASS_IS_ARRAY(OBJECT_CLASS(obj)))
-		SignalError("java.lang.IllegalArgumentException", "");
-
-	clazz = CLASS_ELEMENT_TYPE(OBJECT_CLASS(obj));
-	
-	if ( clazz == booleanClass ) {
-		HArrayOfBoolean *arr = (HArrayOfBoolean *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		return unhand_array(arr)->body[elem];
-	} else {
-		SignalError("java.lang.IllegalArgumentException", "");
-	}
-}
-
-jbyte
-java_lang_reflect_Array_getByte(struct Hjava_lang_Object* obj, jint elem)
-{
-	Hjava_lang_Class *clazz;
-
-	if (!CLASS_IS_ARRAY(OBJECT_CLASS(obj)))
-		SignalError("java.lang.IllegalArgumentException", "");
-
-	clazz = CLASS_ELEMENT_TYPE(OBJECT_CLASS(obj));
-	
-	if ( clazz == byteClass ) {
-		HArrayOfByte *arr = (HArrayOfByte *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		return unhand_array(arr)->body[elem];
-	} else {
-		SignalError("java.lang.IllegalArgumentException", "");
-	}
-}
-
-jchar
-java_lang_reflect_Array_getChar(struct Hjava_lang_Object* obj, jint elem)
-{
-	Hjava_lang_Class *clazz;
-
-	if (!CLASS_IS_ARRAY(OBJECT_CLASS(obj)))
-		SignalError("java.lang.IllegalArgumentException", "");
-
-	clazz = CLASS_ELEMENT_TYPE(OBJECT_CLASS(obj));
-	
-	if ( clazz == charClass ) {
-		HArrayOfChar *arr = (HArrayOfChar *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		return unhand_array(arr)->body[elem];
-	} else if ( clazz == byteClass ) {
-		HArrayOfByte *arr = (HArrayOfByte *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		return unhand_array(arr)->body[elem];
-	} else {
-		SignalError("java.lang.IllegalArgumentException", "");
-	}
-}
-
-jshort
-java_lang_reflect_Array_getShort(struct Hjava_lang_Object* obj, jint elem)
-{
-	Hjava_lang_Class *clazz;
-
-	if (!CLASS_IS_ARRAY(OBJECT_CLASS(obj)))
-		SignalError("java.lang.IllegalArgumentException", "");
-
-	clazz = CLASS_ELEMENT_TYPE(OBJECT_CLASS(obj));
-	
-	if ( clazz == shortClass ) {
-		HArrayOfShort *arr = (HArrayOfShort *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		return unhand_array(arr)->body[elem];
-	} else if ( clazz == byteClass ) {
-		HArrayOfByte *arr = (HArrayOfByte *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		return unhand_array(arr)->body[elem];
-	} else {
-		SignalError("java.lang.IllegalArgumentException", "");
-	}
-}
-
-jint
-java_lang_reflect_Array_getInt(struct Hjava_lang_Object* obj, jint elem)
-{
-	Hjava_lang_Class *clazz;
-
-	if (!CLASS_IS_ARRAY(OBJECT_CLASS(obj)))
-		SignalError("java.lang.IllegalArgumentException", "");
-
-	clazz = CLASS_ELEMENT_TYPE(OBJECT_CLASS(obj));
-	
-	if ( clazz == intClass ) {
-		HArrayOfInt *arr = (HArrayOfInt *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		return unhand_array(arr)->body[elem];
-	} else if ( clazz == shortClass ) {
-		HArrayOfShort *arr = (HArrayOfShort *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		return unhand_array(arr)->body[elem];
-	} else if ( clazz == charClass ) {
-		HArrayOfChar *arr = (HArrayOfChar *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		return unhand_array(arr)->body[elem];
-	} else if ( clazz == byteClass ) {
-		HArrayOfByte *arr = (HArrayOfByte *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		return unhand_array(arr)->body[elem];
-	} else {
-		SignalError("java.lang.IllegalArgumentException", "");
-	}
-}
-
-jlong
-java_lang_reflect_Array_getLong(struct Hjava_lang_Object* obj, jint elem)
-{
-	Hjava_lang_Class *clazz;
-
-	if (!CLASS_IS_ARRAY(OBJECT_CLASS(obj)))
-		SignalError("java.lang.IllegalArgumentException", "");
-
-	clazz = CLASS_ELEMENT_TYPE(OBJECT_CLASS(obj));
-	
-	if ( clazz == longClass ) {
-		HArrayOfLong *arr = (HArrayOfLong *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		return unhand_array(arr)->body[elem];
-	} else if ( clazz == intClass ) {
-		HArrayOfInt *arr = (HArrayOfInt *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		return unhand_array(arr)->body[elem];
-	} else if ( clazz == shortClass ) {
-		HArrayOfShort *arr = (HArrayOfShort *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		return unhand_array(arr)->body[elem];
-	} else if ( clazz == charClass ) {
-		HArrayOfChar *arr = (HArrayOfChar *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		return unhand_array(arr)->body[elem];
-	} else if ( clazz == byteClass ) {
-		HArrayOfByte *arr = (HArrayOfByte *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		return unhand_array(arr)->body[elem];
-	} else {
-		SignalError("java.lang.IllegalArgumentException", "");
-	}
-}
-
-jfloat
-java_lang_reflect_Array_getFloat(struct Hjava_lang_Object* obj, jint elem)
-{
-	Hjava_lang_Class *clazz;
-
-	if (!CLASS_IS_ARRAY(OBJECT_CLASS(obj)))
-		SignalError("java.lang.IllegalArgumentException", "");
-
-	clazz = CLASS_ELEMENT_TYPE(OBJECT_CLASS(obj));
-	
-	if ( clazz == floatClass ) {
-		HArrayOfFloat *arr = (HArrayOfFloat *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		return unhand_array(arr)->body[elem];
-	} else if ( clazz == longClass ) {
-		HArrayOfLong *arr = (HArrayOfLong *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		return unhand_array(arr)->body[elem];
-	} else if ( clazz == intClass ) {
-		HArrayOfInt *arr = (HArrayOfInt *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		return unhand_array(arr)->body[elem];
-	} else if ( clazz == shortClass ) {
-		HArrayOfShort *arr = (HArrayOfShort *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		return unhand_array(arr)->body[elem];
-	} else if ( clazz == charClass ) {
-		HArrayOfChar *arr = (HArrayOfChar *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		return unhand_array(arr)->body[elem];
-	} else if ( clazz == byteClass ) {
-		HArrayOfByte *arr = (HArrayOfByte *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		return unhand_array(arr)->body[elem];
-	} else {
-		SignalError("java.lang.IllegalArgumentException", "");
-	}
-}
-
-jdouble
-java_lang_reflect_Array_getDouble(struct Hjava_lang_Object* obj, jint elem)
-{
-	Hjava_lang_Class *clazz;
-
-	if (!CLASS_IS_ARRAY(OBJECT_CLASS(obj)))
-		SignalError("java.lang.IllegalArgumentException", "");
-
-	clazz = CLASS_ELEMENT_TYPE(OBJECT_CLASS(obj));
-	
-	if ( clazz == doubleClass ) {
-		HArrayOfDouble *arr = (HArrayOfDouble *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		return unhand_array(arr)->body[elem];
-	} else if ( clazz == floatClass ) {
-		HArrayOfFloat *arr = (HArrayOfFloat *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		return unhand_array(arr)->body[elem];
-	} else if ( clazz == longClass ) {
-		HArrayOfLong *arr = (HArrayOfLong *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		return unhand_array(arr)->body[elem];
-	} else if ( clazz == intClass ) {
-		HArrayOfInt *arr = (HArrayOfInt *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		return unhand_array(arr)->body[elem];
-	} else if ( clazz == shortClass ) {
-		HArrayOfShort *arr = (HArrayOfShort *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		return unhand_array(arr)->body[elem];
-	} else if ( clazz == charClass ) {
-		HArrayOfChar *arr = (HArrayOfChar *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		return unhand_array(arr)->body[elem];
-	} else if ( clazz == byteClass ) {
-		HArrayOfByte *arr = (HArrayOfByte *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		return unhand_array(arr)->body[elem];
-	} else {
-		SignalError("java.lang.IllegalArgumentException", "");
-	}
-}
-
-void
-java_lang_reflect_Array_set(struct Hjava_lang_Object* obj, jint elem, struct Hjava_lang_Object* val)
-{
-	Hjava_lang_Class *clazz;
-
-	if (!CLASS_IS_ARRAY(OBJECT_CLASS(obj)))
-		SignalError("java.lang.IllegalArgumentException", "");
-
-	if (!CLASS_IS_PRIMITIVE(CLASS_ELEMENT_TYPE(OBJECT_CLASS(obj)))) {
-		HArrayOfObject *arr = (HArrayOfObject *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		if (val == NULL || soft_instanceof(CLASS_ELEMENT_TYPE(OBJECT_CLASS(obj)), val)) {
-			unhand_array(arr)->body[elem] = val;
-		} else {
-			SignalError("java.lang.IllegalArgumentException", "");
-		}
-		return;
-	}
-
-	clazz = OBJECT_CLASS(val);
-	
-	if ( clazz == javaLangIntegerClass ) {
-		java_lang_reflect_Array_setInt(obj, elem, unhand(((Hjava_lang_Integer *)val))->value );
-	}
-	else if ( clazz == javaLangBooleanClass ) {
-		java_lang_reflect_Array_setBoolean(obj, elem, unhand(((Hjava_lang_Boolean *)val))->value );
-	}
-	else if ( clazz == javaLangByteClass ) {
-		java_lang_reflect_Array_setByte(obj, elem, unhand(((Hjava_lang_Byte *)val))->value );
-	}
-	else if ( clazz == javaLangShortClass ) {
-		java_lang_reflect_Array_setShort(obj, elem, unhand(((Hjava_lang_Short *)val))->value );
-	}
-	else if ( clazz == javaLangCharacterClass ) {
-		java_lang_reflect_Array_setChar(obj, elem, unhand(((Hjava_lang_Character *)val))->value );
-	}
-	else if ( clazz == javaLangLongClass ) {
-		java_lang_reflect_Array_setLong(obj, elem, unhand(((Hjava_lang_Long *)val))->value );
-	}
-	else if ( clazz == javaLangFloatClass ) {
-		java_lang_reflect_Array_setFloat(obj, elem, unhand(((Hjava_lang_Float *)val))->value );
-	}
-	else if ( clazz == javaLangDoubleClass ) {
-		java_lang_reflect_Array_setDouble(obj, elem, unhand(((Hjava_lang_Double *)val))->value );
-	} else {
-		SignalError("java.lang.IllegalArgumentException", "");
-      	}
-}
-
-void
-java_lang_reflect_Array_setBoolean(struct Hjava_lang_Object* obj, jint elem, jbool val)
-{
-	Hjava_lang_Class *clazz;
-
-	if (!CLASS_IS_ARRAY(OBJECT_CLASS(obj)))
-		SignalError("java.lang.IllegalArgumentException", "");
-
-	clazz = CLASS_ELEMENT_TYPE(OBJECT_CLASS(obj));
-	
-	if ( clazz == booleanClass ) {
-		HArrayOfBoolean *arr = (HArrayOfBoolean *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		unhand_array(arr)->body[elem] = val;
-	} else {
-		SignalError("java.lang.IllegalArgumentException", "");
-	}
-}
-
-void
-java_lang_reflect_Array_setByte(struct Hjava_lang_Object* obj, jint elem, jbyte val)
-{
-	Hjava_lang_Class *clazz;
-
-	if (!CLASS_IS_ARRAY(OBJECT_CLASS(obj)))
-		SignalError("java.lang.IllegalArgumentException", "");
-
-	clazz = CLASS_ELEMENT_TYPE(OBJECT_CLASS(obj));
-	
-	if ( clazz == byteClass ) {
-		HArrayOfByte *arr = (HArrayOfByte *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		unhand_array(arr)->body[elem] = val;
-	} else if ( clazz == shortClass ) {
-		HArrayOfShort *arr = (HArrayOfShort *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		unhand_array(arr)->body[elem] = val;
-	} else if ( clazz == charClass ) {
-		HArrayOfChar *arr = (HArrayOfChar *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		unhand_array(arr)->body[elem] = val;
-	} else if ( clazz == intClass ) {
-		HArrayOfInt *arr = (HArrayOfInt *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		unhand_array(arr)->body[elem] = val;
-	} else if ( clazz == longClass ) {
-		HArrayOfLong *arr = (HArrayOfLong *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		unhand_array(arr)->body[elem] = val;
-	} else if ( clazz == floatClass ) {
-		HArrayOfFloat *arr = (HArrayOfFloat *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		unhand_array(arr)->body[elem] = val;
-	} else if ( clazz == doubleClass ) {
-		HArrayOfDouble *arr = (HArrayOfDouble *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		unhand_array(arr)->body[elem] = val;
-	} else {
-		SignalError("java.lang.IllegalArgumentException", "");
-	}
-}
-
-void
-java_lang_reflect_Array_setChar(struct Hjava_lang_Object* obj, jint elem, jchar val)
-{
-	Hjava_lang_Class *clazz;
-
-	if (!CLASS_IS_ARRAY(OBJECT_CLASS(obj)))
-		SignalError("java.lang.IllegalArgumentException", "");
-
-	clazz = CLASS_ELEMENT_TYPE(OBJECT_CLASS(obj));
-	
-	if ( clazz == charClass ) {
-		HArrayOfChar *arr = (HArrayOfChar *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		unhand_array(arr)->body[elem] = val;
-	} else if ( clazz == intClass ) {
-		HArrayOfInt *arr = (HArrayOfInt *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		unhand_array(arr)->body[elem] = val;
-	} else if ( clazz == longClass ) {
-		HArrayOfLong *arr = (HArrayOfLong *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		unhand_array(arr)->body[elem] = val;
-	} else if ( clazz == floatClass ) {
-		HArrayOfFloat *arr = (HArrayOfFloat *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		unhand_array(arr)->body[elem] = val;
-	} else if ( clazz == doubleClass ) {
-		HArrayOfDouble *arr = (HArrayOfDouble *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		unhand_array(arr)->body[elem] = val;
-	} else {
-		SignalError("java.lang.IllegalArgumentException", "");
-	}
-}
-
-void
-java_lang_reflect_Array_setShort(struct Hjava_lang_Object* obj, jint elem, jshort val)
-{
-	Hjava_lang_Class *clazz;
-
-	if (!CLASS_IS_ARRAY(OBJECT_CLASS(obj)))
-		SignalError("java.lang.IllegalArgumentException", "");
-
-	clazz = CLASS_ELEMENT_TYPE(OBJECT_CLASS(obj));
-	
-	if ( clazz == shortClass ) {
-		HArrayOfShort *arr = (HArrayOfShort *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		unhand_array(arr)->body[elem] = val;
-	} else if ( clazz == intClass ) {
-		HArrayOfInt *arr = (HArrayOfInt *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		unhand_array(arr)->body[elem] = val;
-	} else if ( clazz == longClass ) {
-		HArrayOfLong *arr = (HArrayOfLong *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		unhand_array(arr)->body[elem] = val;
-	} else if ( clazz == floatClass ) {
-		HArrayOfFloat *arr = (HArrayOfFloat *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		unhand_array(arr)->body[elem] = val;
-	} else if ( clazz == doubleClass ) {
-		HArrayOfDouble *arr = (HArrayOfDouble *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		unhand_array(arr)->body[elem] = val;
-	} else {
-		SignalError("java.lang.IllegalArgumentException", "");
-	}
-}
-
-void
-java_lang_reflect_Array_setInt(struct Hjava_lang_Object* obj, jint elem, jint val)
-{
-	Hjava_lang_Class *clazz;
-
-	if (!CLASS_IS_ARRAY(OBJECT_CLASS(obj)))
-		SignalError("java.lang.IllegalArgumentException", "");
-
-	clazz = CLASS_ELEMENT_TYPE(OBJECT_CLASS(obj));
-	
-	if ( clazz == intClass ) {
-		HArrayOfInt *arr = (HArrayOfInt *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		unhand_array(arr)->body[elem] = val;
-	} else if ( clazz == longClass ) {
-		HArrayOfLong *arr = (HArrayOfLong *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		unhand_array(arr)->body[elem] = val;
-	} else if ( clazz == floatClass ) {
-		HArrayOfFloat *arr = (HArrayOfFloat *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		unhand_array(arr)->body[elem] = val;
-	} else if ( clazz == doubleClass ) {
-		HArrayOfDouble *arr = (HArrayOfDouble *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		unhand_array(arr)->body[elem] = val;
-	} else {
-		SignalError("java.lang.IllegalArgumentException", "");
-	}
-}
-
-void
-java_lang_reflect_Array_setLong(struct Hjava_lang_Object* obj, jint elem, jlong val)
-{
-	Hjava_lang_Class *clazz;
-
-	if (!CLASS_IS_ARRAY(OBJECT_CLASS(obj)))
-		SignalError("java.lang.IllegalArgumentException", "");
-
-	clazz = CLASS_ELEMENT_TYPE(OBJECT_CLASS(obj));
-	
-	if ( clazz == longClass ) {
-		HArrayOfLong *arr = (HArrayOfLong *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		unhand_array(arr)->body[elem] = val;
-	} else if ( clazz == floatClass ) {
-		HArrayOfFloat *arr = (HArrayOfFloat *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		unhand_array(arr)->body[elem] = val;
-	} else if ( clazz == doubleClass ) {
-		HArrayOfDouble *arr = (HArrayOfDouble *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		unhand_array(arr)->body[elem] = val;
-	} else {
-		SignalError("java.lang.IllegalArgumentException", "");
-	}
-}
-
-void
-java_lang_reflect_Array_setFloat(struct Hjava_lang_Object* obj, jint elem, jfloat val)
-{
-	Hjava_lang_Class *clazz;
-
-	if (!CLASS_IS_ARRAY(OBJECT_CLASS(obj)))
-		SignalError("java.lang.IllegalArgumentException", "");
-
-	clazz = CLASS_ELEMENT_TYPE(OBJECT_CLASS(obj));
-	
-	if ( clazz == floatClass ) {
-		HArrayOfFloat *arr = (HArrayOfFloat *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		unhand_array(arr)->body[elem] = val;
-	} else if ( clazz == doubleClass ) {
-		HArrayOfDouble *arr = (HArrayOfDouble *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		unhand_array(arr)->body[elem] = val;
-	} else {
-		SignalError("java.lang.IllegalArgumentException", "");
-	}
-}
-
-void
-java_lang_reflect_Array_setDouble(struct Hjava_lang_Object* obj, jint elem, jdouble val)
-{
-	Hjava_lang_Class *clazz;
-
-	if (!CLASS_IS_ARRAY(OBJECT_CLASS(obj)))
-		SignalError("java.lang.IllegalArgumentException", "");
-
-	clazz = CLASS_ELEMENT_TYPE(OBJECT_CLASS(obj));
-	
-	if ( clazz == doubleClass ) {
-		HArrayOfDouble *arr = (HArrayOfDouble *)obj;
-		if (elem < 0 || elem >= obj_length(arr))
-			SignalError("java.lang.ArrayIndexOutOfBoundsException", "");
-		
-		unhand_array(arr)->body[elem] = val;
-	} else {
-		SignalError("java.lang.IllegalArgumentException", "");
-	}
-}
-
-struct Hjava_lang_Object*
 java_lang_reflect_Array_newArray(struct Hjava_lang_Class* clazz, jint size)
 {
 	if (size < 0) {
@@ -762,44 +48,3 @@
 	}
 }
 
-struct Hjava_lang_Object*
-java_lang_reflect_Array_multiNewArray(struct Hjava_lang_Class* clazz, HArrayOfInt* sizes)
-{
-	int* dims;
-	int i;
-	int s;
-	Hjava_lang_Object* array;
-	errorInfo info;
-
-	s = obj_length(sizes);
-
-	if (s == 0) {
-		SignalError("java.lang.IllegalArgumentException", "zero dimensions");
-	}
-
-	dims = KCALLOC(s+1, sizeof(int));
-	if (!dims) {
-		postOutOfMemory(&info);
-		throwError(&info);
-	}
-
-	/* Copy dimentions into array */
-	for( i = 0; i < s; i++ ) {
-		dims[i] = unhand_array(sizes)->body[i];
-		if (dims[i] < 0) {
-			SignalError("java.lang.NegativeArraySizeException", "");
-		}
-		clazz = lookupArray(clazz, &info);
-		if (clazz == 0) {
-			KFREE(dims);
-			throwError(&info);
-		}
-	}
-	dims[i] = -1;
-
-	/* Create multi-dimension array */
-	array = newMultiArray(clazz, dims);
-	KFREE(dims);
-
-	return (array);
-}
--- /home/topic/kaffe/libraries/clib/native/Constructor.c	Fri Apr 26 02:33:16 2002
+++ libraries/clib/native/Constructor.c	Mon Apr 29 01:10:27 2002
@@ -25,11 +25,6 @@
 #include <jni.h>
 #include "defs.h"
 
-/* XXX move in header file */
-jobject
-Java_java_lang_reflect_Method_invoke0(JNIEnv* env, jobject _this, 
-	jobject _obj, jobjectArray _argobj);
-
 jint
 java_lang_reflect_Constructor_getModifiers(struct Hjava_lang_reflect_Constructor* this)
 {
@@ -42,30 +37,4 @@
 	assert(slot < clazz->nmethods);
 
 	return (clazz->methods[slot].accflags & ACC_MASK);
-}
-
-jobject
-Java_java_lang_reflect_Constructor_newInstance(JNIEnv* env, jobject _this, jobjectArray argobj)
-{
-	/* 
-	 * We fake a java.lang.reflect.Method Object so that we can call
-	 * Java_java_lang_reflect_Method_invoke0 from here.
-	 *
-	 * The main task Method_invoke does is converting the jobjectArray of
-	 * arguments into a jvalue * array.  Method.invoke0 will invoke the
-	 * right JNI function when it detects that the method is a constructor
-	 */
-	Hjava_lang_reflect_Method meth[1];
-
-	Hjava_lang_reflect_Constructor* this = (Hjava_lang_reflect_Constructor*)_this;
-
-	unhand(meth)->clazz = unhand(this)->clazz;
-	unhand(meth)->slot = unhand(this)->slot;
-	unhand(meth)->name = 0; /* It's a constructor!! */
-	unhand(meth)->returnType = unhand(this)->clazz;
-	unhand(meth)->parameterTypes = unhand(this)->parameterTypes;
-	unhand(meth)->exceptionTypes = unhand(this)->exceptionTypes;
-
-	return Java_java_lang_reflect_Method_invoke0(env, (jobject)meth, 
-			(jobject)NULL, argobj);
 }
--- /home/topic/kaffe/libraries/clib/native/Field.c	Fri Apr 26 02:33:15 2002
+++ libraries/clib/native/Field.c	Sun Apr 28 20:09:07 2002
@@ -38,7 +38,7 @@
 #include "defs.h"
 
 static
-char*
+void*
 getFieldAddress(Hjava_lang_reflect_Field* this, struct Hjava_lang_Object* obj)
 {
         Hjava_lang_Class* clas;
@@ -61,7 +61,7 @@
                 if  (!soft_instanceof(clas, obj)) {
                         SignalError("java.lang.IllegalArgumentException","");
                 }
-                return (((char*)(obj)) + FIELD_BOFFSET(fld));
+                return ((void*)(((char*)(obj)) + FIELD_BOFFSET(fld)));
         }
 }
 
@@ -80,566 +80,112 @@
         return ((jint)(fld->accflags & ACC_MASK));
 }
 
-
 struct Hjava_lang_Object*
-java_lang_reflect_Field_get(Hjava_lang_reflect_Field* this, struct Hjava_lang_Object* obj)
+Java_java_lang_reflect_Field_getObject0(struct Hjava_lang_reflect_Field * this, struct Hjava_lang_Object* obj)
 {
-        Hjava_lang_Class* clas;
-        Field* fld;
-        char* base;
-
-        clas = (Hjava_lang_Class*) unhand(this)->clazz;
-        fld = CLASS_FIELDS(clas) + unhand(this)->slot;
-        base = getFieldAddress(this, obj);
-
-	if ( fld->type == intClass ) {
-		return execute_java_constructor(0, 0, javaLangIntegerClass,
-		    "(I)V", *((jint*)base));
-	}
-	else if ( fld->type == shortClass ) {
-		return execute_java_constructor(0, 0, javaLangShortClass,
-		    "(S)V", *(jshort*)base);
-	}
-	else if ( fld->type == longClass ) {
-		return execute_java_constructor(0, 0, javaLangLongClass,
-		    "(J)V", *(jlong*)base);
-	}
-	else if ( fld->type == byteClass ) {
-		return execute_java_constructor(0, 0, javaLangByteClass,
-		    "(B)V", *(jbyte*)base);
-	}
-	else if ( fld->type == booleanClass ) {
-		return execute_java_constructor(0, 0, javaLangBooleanClass,
-		    "(Z)V", *(jbool*)base);
-	}
-	else if ( fld->type == charClass ) {
-		return execute_java_constructor(0, 0, javaLangCharacterClass,
-		    "(C)V", *(jchar*)base);
-	}
-	else if ( fld->type == floatClass ) {
-		return execute_java_constructor(0, 0, javaLangFloatClass,
-		    "(F)V", *(jfloat*)base);
-	}
-	else if ( fld->type == doubleClass ) {
-		return execute_java_constructor(0, 0, javaLangDoubleClass,
-		    "(D)V", *(jdouble*)base);
-	}
-	else {
-		/* If fld->type isn't one of the above then it's either a
-		 * reference or unresolved (and so a reference).
-		 */
-		return (*(struct Hjava_lang_Object**)base);
-	}
+	return ((struct Hjava_lang_Object*)getFieldAddress(this, obj));
 }
 
-
-jbool 
-java_lang_reflect_Field_getBoolean(struct Hjava_lang_reflect_Field* this, struct Hjava_lang_Object* obj)
+jboolean
+Java_java_lang_reflect_Field_getBoolean0(struct Hjava_lang_reflect_Field * this, struct Hjava_lang_Object* obj)
 {
-        Hjava_lang_Class* clas;
-        Field* fld;
-        char* base;
-
-        clas = (Hjava_lang_Class*) unhand(this)->clazz;
-        fld = CLASS_FIELDS(clas) + unhand(this)->slot;
-        base = getFieldAddress(this, obj);
-
-        if ( fld->type == booleanClass ) {
-                return *(jbool*)base;
-	}
-        else {
-                SignalError("java.lang.IllegalArgumentException", "");
-	}
+	return (*(jboolean*)getFieldAddress(this, obj));
 }
 
-
-jbyte 
-java_lang_reflect_Field_getByte(struct Hjava_lang_reflect_Field* this, struct Hjava_lang_Object* obj)
+jbyte
+Java_java_lang_reflect_Field_getByte0(struct Hjava_lang_reflect_Field * this, struct Hjava_lang_Object* obj)
 {
-        Hjava_lang_Class* clas;
-        Field* fld;
-        char* base;
-
-        clas = (Hjava_lang_Class*) unhand(this)->clazz;
-        fld = CLASS_FIELDS(clas) + unhand(this)->slot;
-        base = getFieldAddress(this, obj);
-
-        if ( fld->type == byteClass ) {
-                return *(jbyte*)base;
-	}
-        else {
-                SignalError("java.lang.IllegalArgumentException", "");
-	}
+	return (*(jbyte*)getFieldAddress(this, obj));
 }
 
-jchar 
-java_lang_reflect_Field_getChar(struct Hjava_lang_reflect_Field* this, struct Hjava_lang_Object* obj)
+jchar
+Java_java_lang_reflect_Field_getChar0(struct Hjava_lang_reflect_Field * this, struct Hjava_lang_Object* obj)
 {
-        Hjava_lang_Class* clas;
-        Field* fld;
-        char* base;
-
-        clas = (Hjava_lang_Class*) unhand(this)->clazz;
-        fld = CLASS_FIELDS(clas) + unhand(this)->slot;
-        base = getFieldAddress(this, obj);
-
-        if ( fld->type == charClass ) {
-                return *(jchar*)base;
-	}
-        else {
-                SignalError("java.lang.IllegalArgumentException", "");
-	}
+	return (*(jchar*)getFieldAddress(this, obj));
 }
 
 
-jshort 
-java_lang_reflect_Field_getShort(struct Hjava_lang_reflect_Field* this, struct Hjava_lang_Object* obj)
+jshort
+Java_java_lang_reflect_Field_getShort0(struct Hjava_lang_reflect_Field * this, struct Hjava_lang_Object* obj)
 {
-        Hjava_lang_Class* clas;
-        Field* fld;
-        char* base;
-
-        clas = (Hjava_lang_Class*) unhand(this)->clazz;
-        fld = CLASS_FIELDS(clas) + unhand(this)->slot;
-        base = getFieldAddress(this, obj);
-
-        if ( fld->type == shortClass ) {
-                return *(jshort*)base;
-	}
-        else if ( fld->type == byteClass ) {
-                return (jshort)(*(jbyte*)base);
-	}
-        else {
-                SignalError("java.lang.IllegalArgumentException", "");
-	}
+	return (*(jshort*)getFieldAddress(this, obj));
 }
 
-jint 
-java_lang_reflect_Field_getInt(struct Hjava_lang_reflect_Field* this, struct Hjava_lang_Object* obj)
+jint
+Java_java_lang_reflect_Field_getInt0(struct Hjava_lang_reflect_Field * this, struct Hjava_lang_Object* obj)
 {
-        Hjava_lang_Class* clas;
-        Field* fld;
-        char* base;
-
-        clas = (Hjava_lang_Class*) unhand(this)->clazz;
-        fld = CLASS_FIELDS(clas) + unhand(this)->slot;
-        base = getFieldAddress(this, obj);
-
-        if ( fld->type == intClass ) {
-                return *(jint*)base;
-	}
-        else if ( fld->type == shortClass ) {
-                return (jint)(*(jshort*)base);
-	}
-        else if ( fld->type == byteClass ) {
-                return (jint)(*(jbyte*)base);
-	}
-        else if ( fld->type == charClass ) {
-                return (jint)(*(jchar*)base);
-	}
-        else {
-                SignalError("java.lang.IllegalArgumentException", "");
-	}
+	return (*(jint*)getFieldAddress(this, obj));
 }
 
-jlong 
-java_lang_reflect_Field_getLong(struct Hjava_lang_reflect_Field* this, struct Hjava_lang_Object* obj)
+jlong
+Java_java_lang_reflect_Field_getLong0(struct Hjava_lang_reflect_Field * this, struct Hjava_lang_Object* obj)
 {
-        Hjava_lang_Class* clas;
-        Field* fld;
-        char* base;
-
-        clas = (Hjava_lang_Class*) unhand(this)->clazz;
-        fld = CLASS_FIELDS(clas) + unhand(this)->slot;
-        base = getFieldAddress(this, obj);
-
-        if ( fld->type == longClass ) {
-                return *(jlong*)base;
-	}
-        else if ( fld->type == intClass ) {
-                return (jlong)(*(jint*)base);
-	}
-        else if ( fld->type == shortClass ) {
-                return (jlong)(*(jshort*)base);
-	}
-        else if ( fld->type == byteClass ) {
-                return (jlong)(*(jbyte*)base);
-	}
-        else if ( fld->type == charClass ) {
-                return (jlong)(*(jchar*)base);
-	}
-        else {
-                SignalError("java.lang.IllegalArgumentException", "");
-	}
+	return (*(jlong*)getFieldAddress(this, obj));
 }
 
-jfloat 
-java_lang_reflect_Field_getFloat(struct Hjava_lang_reflect_Field* this, struct Hjava_lang_Object* obj)
+jfloat
+Java_java_lang_reflect_Field_getFloat0(struct Hjava_lang_reflect_Field * this, struct Hjava_lang_Object* obj)
 {
-        Hjava_lang_Class* clas;
-        Field* fld;
-        char* base;
-
-        clas = (Hjava_lang_Class*) unhand(this)->clazz;
-        fld = CLASS_FIELDS(clas) + unhand(this)->slot;
-        base = getFieldAddress(this, obj);
-
-        if ( fld->type == floatClass ) {
-                return *(jfloat*)base;
-	}
-        else if ( fld->type == longClass ) {
-                return (jfloat)(*(jlong*)base);
-	}
-        else if ( fld->type == intClass ) {
-                return (jfloat)(*(jint*)base);
-	}
-        else if ( fld->type == shortClass ) {
-                return (jfloat)(*(jshort*)base);
-	}
-        else if ( fld->type == byteClass ) {
-                return (jfloat)(*(jbyte*)base);
-	}
-        else if ( fld->type == charClass ) {
-                return (jfloat)(*(jchar*)base);
-	}
-        else {
-                SignalError("java.lang.IllegalArgumentException", "");
-	}
+	return (*(jfloat*)getFieldAddress(this, obj));
 }
 
-jdouble 
-java_lang_reflect_Field_getDouble(struct Hjava_lang_reflect_Field* this, struct Hjava_lang_Object* obj)
+jdouble
+Java_java_lang_reflect_Field_getDouble0(struct Hjava_lang_reflect_Field * this, struct Hjava_lang_Object* obj)
 {
-        Hjava_lang_Class* clas;
-        Field* fld;
-        char* base;
-
-        clas = (Hjava_lang_Class*) unhand(this)->clazz;
-        fld = CLASS_FIELDS(clas) + unhand(this)->slot;
-        base = getFieldAddress(this, obj);
-
-        if ( fld->type == doubleClass ) {
-                return *(jdouble*)base;
-	}
-        else if ( fld->type == floatClass ) {
-                return (jdouble)(*(jfloat*)base);
-	}
-        else if ( fld->type == longClass ) {
-                return (jdouble)(*(jlong*)base);
-	}
-        else if ( fld->type == intClass ) {
-                return (jdouble)(*(jint*)base);
-	}
-        else if ( fld->type == shortClass ) {
-                return (jdouble)(*(jshort*)base);
-	}
-        else if ( fld->type == byteClass ) {
-                return (jdouble)(*(jbyte*)base);
-	}
-        else if ( fld->type == charClass ) {
-                return (jdouble)(*(jchar*)base);
-	}
-        else {
-                SignalError("java.lang.IllegalArgumentException", "");
-	}
+	return (*(jdouble*)getFieldAddress(this, obj));
 }
 
 
-void 
-java_lang_reflect_Field_setBoolean(struct Hjava_lang_reflect_Field* this, struct Hjava_lang_Object* obj, jbool val )
+void
+Java_java_lang_reflect_Field_setBoolean(struct Hjava_lang_reflect_Field * this, struct Hjava_lang_Object* obj, jboolean val)
 {
-        Hjava_lang_Class* clas;
-        Field* fld;
-        char* base;
-
-        clas = (Hjava_lang_Class*) unhand(this)->clazz;
-        fld = CLASS_FIELDS(clas) + unhand(this)->slot;
-        base = getFieldAddress(this, obj);
-
-        if (fld->accflags & ACC_FINAL) {
-                SignalError("java.lang.IllegalAccessException", "field is final");
-        }
-
-        if ( fld->type == booleanClass ) {
-                *(jbool*)base = val;
-	}
-        else {
-                SignalError("java.lang.IllegalArgumentException", "");
-	}
+	*(jboolean*)getFieldAddress(this, obj) = val;
 }
 
-void 
-java_lang_reflect_Field_setByte(struct Hjava_lang_reflect_Field* this, struct Hjava_lang_Object* obj, jbyte val )
+void
+Java_java_lang_reflect_Field_setByte(struct Hjava_lang_reflect_Field * this, struct Hjava_lang_Object* obj, jbyte val)
 {
-        Hjava_lang_Class* clas;
-        Field* fld;
-        char* base;
-
-        clas = (Hjava_lang_Class*) unhand(this)->clazz;
-        fld = CLASS_FIELDS(clas) + unhand(this)->slot;
-        base = getFieldAddress(this, obj);
-
-        if (fld->accflags & ACC_FINAL) {
-                SignalError("java.lang.IllegalAccessException", "field is final");
-        }
-
-        if ( fld->type == byteClass ) {
-                *(jbyte*)base = val;
-	}
-        else if ( fld->type == shortClass ) {
-                *(jshort*)base = (jshort)val;
-	}
-        else if ( fld->type == intClass ) {
-                *(jint*)base = (jint)val;
-	}
-        else if ( fld->type == longClass ) {
-                *(jlong*)base = (jlong)val;
-	}
-        else if ( fld->type == floatClass ) {
-                *(jfloat*)base = (jfloat)val;
-	}
-        else if ( fld->type == doubleClass ) {
-                *(jdouble*)base =(jdouble)val;
-	}
-        else {
-                SignalError("java.lang.IllegalArgumentException", "");
-	}
+	*(jbyte*)getFieldAddress(this, obj) = val;
 }
 
-void 
-java_lang_reflect_Field_setChar(struct Hjava_lang_reflect_Field* this, struct Hjava_lang_Object* obj, jchar val )
+void
+Java_java_lang_reflect_Field_setChar(struct Hjava_lang_reflect_Field * this, struct Hjava_lang_Object* obj, jchar val)
 {
-        Hjava_lang_Class* clas;
-        Field* fld;
-        char* base;
-
-        clas = (Hjava_lang_Class*) unhand(this)->clazz;
-        fld = CLASS_FIELDS(clas) + unhand(this)->slot;
-        base = getFieldAddress(this, obj);
-
-        if (fld->accflags & ACC_FINAL) {
-                SignalError("java.lang.IllegalAccessException", "field is final");
-        }
-
-        if ( fld->type == charClass ) {
-                *(jchar*)base = val;
-	}
-        else if ( fld->type == intClass ) {
-                *(jint*)base = (jint)val;
-	}
-        else if ( fld->type == longClass ) {
-                *(jlong*)base = (jlong)val;
-	}
-        else if ( fld->type == floatClass ) {
-                *(jfloat*)base = (jfloat)val;
-	}
-        else if ( fld->type == doubleClass ) {
-                *(jdouble*)base =(jdouble)val;
-	}
-        else {
-                SignalError("java.lang.IllegalArgumentException", "");
-	}
+	*(jchar*)getFieldAddress(this, obj) = val;
 }
 
-void 
-java_lang_reflect_Field_setShort(struct Hjava_lang_reflect_Field* this, struct Hjava_lang_Object* obj, jshort val )
+void
+Java_java_lang_reflect_Field_setShort(struct Hjava_lang_reflect_Field * this, struct Hjava_lang_Object* obj, jshort val)
 {
-        Hjava_lang_Class* clas;
-        Field* fld;
-        char* base;
-
-        clas = (Hjava_lang_Class*) unhand(this)->clazz;
-        fld = CLASS_FIELDS(clas) + unhand(this)->slot;
-        base = getFieldAddress(this, obj);
-
-        if (fld->accflags & ACC_FINAL) {
-                SignalError("java.lang.IllegalAccessException", "field is final");
-        }
-
-        if ( fld->type == shortClass ) {
-                *(jshort*)base = val;
-	}
-        else if ( fld->type == intClass ) {
-                *(jint*)base = (jint)val;
-	}
-        else if ( fld->type == longClass ) {
-                *(jlong*)base = (jlong)val;
-	}
-        else if ( fld->type == floatClass ) {
-                *(jfloat*)base = (jfloat)val;
-	}
-        else if ( fld->type == doubleClass ) {
-                *(jdouble*)base =(jdouble)val;
-	}
-        else {
-                SignalError("java.lang.IllegalArgumentException", "");
-	}
+	*(jshort*)getFieldAddress(this, obj) = val;
 }
 
-void 
-java_lang_reflect_Field_setInt(struct Hjava_lang_reflect_Field* this, struct Hjava_lang_Object* obj, jint val )
+void
+Java_java_lang_reflect_Field_setInt(struct Hjava_lang_reflect_Field * this, struct Hjava_lang_Object* obj, jint val)
 {
-        Hjava_lang_Class* clas;
-        Field* fld;
-        char* base;
-
-        clas = (Hjava_lang_Class*) unhand(this)->clazz;
-        fld = CLASS_FIELDS(clas) + unhand(this)->slot;
-        base = getFieldAddress(this, obj);
-
-        if (fld->accflags & ACC_FINAL) {
-                SignalError("java.lang.IllegalAccessException", "field is final");
-        }
-
-        if ( fld->type == intClass ) {
-                *(jint*)base = val;
-	}
-        else if ( fld->type == longClass ) {
-                *(jlong*)base = (jlong)val;
-	}
-        else if ( fld->type == floatClass ) {
-                *(jfloat*)base = (jfloat)val;
-	}
-        else if ( fld->type == doubleClass ) {
-                *(jdouble*)base =(jdouble)val;
-	}
-        else {
-                SignalError("java.lang.IllegalArgumentException", "");
-	}
+	*(jint*)getFieldAddress(this, obj) = val;
 }
 
-void 
-java_lang_reflect_Field_setLong(struct Hjava_lang_reflect_Field* this, struct Hjava_lang_Object* obj, jlong val )
+void
+Java_java_lang_reflect_Field_setLong(struct Hjava_lang_reflect_Field * this, struct Hjava_lang_Object* obj, jlong val)
 {
-        Hjava_lang_Class* clas;
-        Field* fld;
-        char* base;
-
-        clas = (Hjava_lang_Class*) unhand(this)->clazz;
-        fld = CLASS_FIELDS(clas) + unhand(this)->slot;
-        base = getFieldAddress(this, obj);
-
-        if (fld->accflags & ACC_FINAL) {
-                SignalError("java.lang.IllegalAccessException", "field is final");
-        }
-
-        if ( fld->type == longClass ) {
-                *(jlong*)base = val;
-	}
-        else if ( fld->type == floatClass ) {
-                *(jfloat*)base = (jfloat)val;
-	}
-        else if ( fld->type == doubleClass ) {
-                *(jdouble*)base = (jdouble)val;
-	}
-        else {
-                SignalError("java.lang.IllegalArgumentException", "");
-	}
+	*(jlong*)getFieldAddress(this, obj) = val;
 }
 
-void 
-java_lang_reflect_Field_setFloat(struct Hjava_lang_reflect_Field* this, struct Hjava_lang_Object* obj, jfloat val )
+void
+Java_java_lang_reflect_Field_setFloat(struct Hjava_lang_reflect_Field * this, struct Hjava_lang_Object* obj, jfloat val)
 {
-        Hjava_lang_Class* clas;
-        Field* fld;
-        char* base;
-
-        clas = (Hjava_lang_Class*) unhand(this)->clazz;
-        fld = CLASS_FIELDS(clas) + unhand(this)->slot;
-        base = getFieldAddress(this, obj);
-
-        if (fld->accflags & ACC_FINAL) {
-                SignalError("java.lang.IllegalAccessException", "field is final");
-        }
-
-        if ( fld->type == floatClass ) {
-                *(jfloat*)base = val;
-	}
-        else if ( fld->type == doubleClass ) {
-                *(jdouble*)base =(jdouble)val;
-	}
-        else {
-                SignalError("java.lang.IllegalArgumentException", "");
-	}
+	*(jfloat*)getFieldAddress(this, obj) = val;
 }
 
-void 
-java_lang_reflect_Field_setDouble(struct Hjava_lang_reflect_Field* this, struct Hjava_lang_Object* obj, jdouble val )
+void
+Java_java_lang_reflect_Field_setDouble(struct Hjava_lang_reflect_Field * this, struct Hjava_lang_Object* obj, jdouble val)
 {
-        Hjava_lang_Class* clas;
-        Field* fld;
-        char* base;
-
-        clas = (Hjava_lang_Class*) unhand(this)->clazz;
-        fld = CLASS_FIELDS(clas) + unhand(this)->slot;
-        base = getFieldAddress(this, obj);
-
-        if (fld->accflags & ACC_FINAL) {
-                SignalError("java.lang.IllegalAccessException", "field is final");
-        }
-
-        if ( fld->type == doubleClass ) {
-                *(jdouble*)base = val;
-	}
-        else {
-                SignalError("java.lang.IllegalArgumentException", "");
-	}
+	*(jdouble*)getFieldAddress(this, obj) = val;
 }
 
 void
-java_lang_reflect_Field_set(Hjava_lang_reflect_Field* this, struct Hjava_lang_Object* obj, struct Hjava_lang_Object* val)
+Java_java_lang_reflect_Field_set(struct Hjava_lang_reflect_Field * this, struct Hjava_lang_Object* obj, struct Hjava_lang_Object* val)
 {
-        Hjava_lang_Class* clas, *clazz;
-        Field* fld;
-        char* base;
-	errorInfo info;
-	Hjava_lang_Class* ftype;
-
-        clas = (Hjava_lang_Class*) unhand(this)->clazz;
-        fld = CLASS_FIELDS(clas) + unhand(this)->slot;
-
-        if (fld->accflags & ACC_FINAL) {
-                SignalError("java.lang.IllegalAccessException", "field is final");
-        }
-	
-	ftype = resolveFieldType(fld, clas, &info);
-	if (ftype == 0) {
-		throwError(&info);
-	}
-
-	if (FIELD_ISREF(fld) && (val == NULL || soft_instanceof(ftype, val))) {
-		base = getFieldAddress(this, obj);
-		*(struct Hjava_lang_Object**)base = val;
-		return;
-	}
-	
-	clazz = OBJECT_CLASS(val);
-
-	if ( clazz == javaLangIntegerClass ) {
-		java_lang_reflect_Field_setInt(this, obj, unhand(((Hjava_lang_Integer *)val))->value );
-	}
-	else if ( clazz == javaLangBooleanClass ) {
-		java_lang_reflect_Field_setBoolean(this, obj, unhand(((Hjava_lang_Boolean *)val))->value );
-	}
-	else if ( clazz == javaLangByteClass ) {
-		java_lang_reflect_Field_setByte(this, obj, unhand(((Hjava_lang_Byte *)val))->value );
-	}
-	else if ( clazz == javaLangShortClass ) {
-		java_lang_reflect_Field_setShort(this, obj, unhand(((Hjava_lang_Short *)val))->value );
-	}
-	else if ( clazz == javaLangCharacterClass ) {
-		java_lang_reflect_Field_setChar(this, obj, unhand(((Hjava_lang_Character *)val))->value );
-	}
-	else if ( clazz == javaLangLongClass ) {
-		java_lang_reflect_Field_setLong(this, obj, unhand(((Hjava_lang_Long *)val))->value );
-	}
-	else if ( clazz == javaLangFloatClass ) {
-		java_lang_reflect_Field_setFloat(this, obj, unhand(((Hjava_lang_Float *)val))->value );
-	}
-	else if ( clazz == javaLangDoubleClass ) {
-		java_lang_reflect_Field_setDouble(this, obj, unhand(((Hjava_lang_Double *)val))->value );
-	}
-	else {
-		SignalError("java.lang.IllegalArgumentException", "can't assign object to a primitive type");
-        }
+	*(jobject*)getFieldAddress(this, obj) = val;
 }
--- /home/topic/kaffe/libraries/clib/native/Method.c	Fri Apr 26 02:33:16 2002
+++ libraries/clib/native/Method.c	Mon Apr 29 00:42:37 2002
@@ -34,6 +34,67 @@
 #include "jni.h"
 #include "defs.h"
 
+static jclass Zclass;
+static jclass Bclass;
+static jclass Sclass;
+static jclass Cclass;
+static jclass Iclass;
+static jclass Jclass;
+static jclass Fclass;
+static jclass Dclass;
+static jfieldID Zvalue;
+static jfieldID Bvalue;
+static jfieldID Svalue;
+static jfieldID Cvalue;
+static jfieldID Ivalue;
+static jfieldID Jvalue;
+static jfieldID Fvalue;
+static jfieldID Dvalue;
+static jmethodID Zmeth;
+static jmethodID Bmeth;
+static jmethodID Smeth;
+static jmethodID Cmeth;
+static jmethodID Imeth;
+static jmethodID Jmeth;
+static jmethodID Fmeth;
+static jmethodID Dmeth;
+
+void
+Java_java_lang_reflect_Method_init0(JNIEnv* env, jclass clazz)
+{
+	Zclass = (*env)->FindClass(env, "java.lang.Boolean");
+	Zvalue = (*env)->GetFieldID(env, Zclass, "value", "Z");
+	Zmeth = (*env)->GetMethodID(env, Zclass, "<init>", "(Z)V");
+
+	Bclass = (*env)->FindClass(env, "java.lang.Byte");
+	Bvalue = (*env)->GetFieldID(env, Bclass, "value", "B");
+	Bmeth = (*env)->GetMethodID(env, Bclass, "<init>", "(B)V");
+
+	Sclass = (*env)->FindClass(env, "java.lang.Short");
+	Svalue = (*env)->GetFieldID(env, Sclass, "value", "S");
+	Smeth = (*env)->GetMethodID(env, Sclass, "<init>", "(S)V");
+
+	Cclass = (*env)->FindClass(env, "java.lang.Character");
+	Cvalue = (*env)->GetFieldID(env, Cclass, "value", "C");
+	Cmeth = (*env)->GetMethodID(env, Cclass, "<init>", "(C)V");
+
+	Iclass = (*env)->FindClass(env, "java.lang.Integer");
+	Ivalue = (*env)->GetFieldID(env, Iclass, "value", "I");
+	Imeth = (*env)->GetMethodID(env, Iclass, "<init>", "(I)V");
+
+	Jclass = (*env)->FindClass(env, "java.lang.Long");
+	Jvalue = (*env)->GetFieldID(env, Jclass, "value", "J");
+	Jmeth = (*env)->GetMethodID(env, Jclass, "<init>", "(J)V");
+
+	Fclass = (*env)->FindClass(env, "java.lang.Float");
+	Fvalue = (*env)->GetFieldID(env, Fclass, "value", "F");
+	Fmeth = (*env)->GetMethodID(env, Fclass, "<init>", "(F)V");
+
+	Dclass = (*env)->FindClass(env, "java.lang.Double");
+	Dvalue = (*env)->GetFieldID(env, Dclass, "value", "D");
+	Dmeth = (*env)->GetMethodID(env, Dclass, "<init>", "(D)V");
+}
+
 jint
 java_lang_reflect_Method_getModifiers(struct Hjava_lang_reflect_Method* this)
 {
@@ -61,16 +122,15 @@
 Java_java_lang_reflect_Method_invoke0(JNIEnv* env, jobject _this, jobject _obj, jobjectArray _argobj)
 {
 	Hjava_lang_Class* clazz;
-	Hjava_lang_Object* robj;
+	jarray paramtypes;
+	jobject arg;
+	jclass argc;
 	Method* meth;
 	jint slot;
 	jvalue args[255]; /* should this be allocated dynamically? */
 	jvalue ret;
-	Hjava_lang_Class *a, *t;
-	Hjava_lang_Object** body;
-	int i;
-	int j;
 	int len;
+	int i;
 	char rettype;
 	errorInfo info;
 
@@ -81,6 +141,7 @@
 	jthrowable targetexc;
 
 	clazz = unhand(this)->clazz;
+	paramtypes = unhand(this)->parameterTypes;
 
 	/* 
 	 * A method invocation via reflection is a first active use, so
@@ -100,147 +161,45 @@
 	/* Note: we assume here that `meth' is identical to the jmethodID which
 	 * would be returned by JNIEnv::GetMethodID for this method.
 	 */
-	meth = &clazz->methods[slot];
+	meth = &CLASS_METHODS(clazz)[slot];
 	len = argobj ? obj_length(argobj) : 0;
-	body = argobj ? OBJARRAY_DATA(argobj) : 0;
-	for (i = j = 0; i < len; ++i, ++j) {
-		t = getClassFromSignaturePart(METHOD_ARG_TYPE(meth, i),
-					  meth->class->loader, &info);
-		if (t == 0) {
-			throwError(&info);
+
+	rettype = *METHOD_RET_TYPE(meth);
+
+	for (i = len - 1; i >= 0; i--) {
+		arg = (*env)->GetObjectArrayElement(env, argobj, i);
+		argc = (*env)->GetObjectArrayElement(env, paramtypes, i);
+		if (!CLASS_IS_PRIMITIVE((Hjava_lang_Class*)argc)) {
+			args[i].l = arg;
 		}
-		a = body[i] ? OBJECT_CLASS(body[i]) : 0;
-		if (CLASS_IS_PRIMITIVE(t)) switch (CLASS_PRIM_SIG(t)) {
-		case 'Z':
-			if (a == javaLangBooleanClass) {
-				args[j].z = unhand((Hjava_lang_Boolean*)body[i])->value;
-			} else {
-				SignalError("java.lang.IllegalArgumentException", "expecting boolean value");
-			}
-			break;
-		case 'B':
-			if (a == javaLangByteClass) {
-				args[j].b = unhand((Hjava_lang_Byte*)body[i])->value;
-			} else {
-				SignalError("java.lang.IllegalArgumentException", "expecting byte value");
-			}
+		else switch (CLASS_PRIM_SIG((Hjava_lang_Class*)argc)) {
+		case 'I':
+			args[i].i = (*env)->GetIntField(env, arg, Ivalue);
 			break;
-		case 'C':
-			if (a == javaLangCharacterClass) {
-				args[j].c = unhand((Hjava_lang_Character*)body[i])->value;
-			}
-			else if (a == javaLangByteClass) {
-				args[j].c = unhand((Hjava_lang_Byte*)body[i])->value;
-			} else {
-				SignalError("java.lang.IllegalArgumentException", "expecting character value");
-			}
+		case 'Z':
+			args[i].z = (*env)->GetBooleanField(env, arg, Zvalue);
 			break;
 		case 'S':
-			if (a == javaLangShortClass) {
-				args[j].s = unhand((Hjava_lang_Short*)body[i])->value;
-			}
-			else if (a == javaLangByteClass) {
-				args[j].s = unhand((Hjava_lang_Byte*)body[i])->value;
-			} else {
-				SignalError("java.lang.IllegalArgumentException", "expecting short value");
-			}
+			args[i].s = (*env)->GetShortField(env, arg, Svalue);
 			break;
-		case 'I':
-			if (a == javaLangIntegerClass) {
-				args[j].i = unhand((Hjava_lang_Integer*)body[i])->value;
-			}
-			else if (a == javaLangCharacterClass) {
-				args[j].i = unhand((Hjava_lang_Character*)body[i])->value;
-			}
-			else if (a == javaLangShortClass) {
-				args[j].i = unhand((Hjava_lang_Short*)body[i])->value;
-			}
-			else if (a == javaLangByteClass) {
-				args[j].i = unhand((Hjava_lang_Byte*)body[i])->value;
-			} else {
-				SignalError("java.lang.IllegalArgumentException", "expecting int value");
-			}
+		case 'B':
+			args[i].b = (*env)->GetByteField(env, arg, Bvalue);
 			break;
-		case 'J':
-			if (a == javaLangLongClass) {
-				args[j].j = unhand((Hjava_lang_Long*)body[i])->value;
-			}
-			else if (a == javaLangIntegerClass) {
-				args[j].j = unhand((Hjava_lang_Integer*)body[i])->value;
-			}
-			else if (a == javaLangCharacterClass) {
-				args[j].j = unhand((Hjava_lang_Character*)body[i])->value;
-			}
-			else if (a == javaLangShortClass) {
-				args[j].j = unhand((Hjava_lang_Short*)body[i])->value;
-			}
-			else if (a == javaLangByteClass) {
-				args[j].j = unhand((Hjava_lang_Byte*)body[i])->value;
-			} else {
-				SignalError("java.lang.IllegalArgumentException", "expecting long value");
-			}
-			++j;
+		case 'C':
+			args[i].c = (*env)->GetCharField(env, arg, Cvalue);
 			break;
 		case 'F':
-			if (a == javaLangFloatClass) {
-				args[j].f = unhand((Hjava_lang_Float*)body[i])->value;
-			}
-			else if (a == javaLangLongClass) {
-				args[j].f = unhand((Hjava_lang_Long*)body[i])->value;
-			}
-			else if (a == javaLangIntegerClass) {
-				args[j].f = unhand((Hjava_lang_Integer*)body[i])->value;
-			}
-			else if (a == javaLangCharacterClass) {
-				args[j].f = unhand((Hjava_lang_Character*)body[i])->value;
-			}
-			else if (a == javaLangShortClass) {
-				args[j].f = unhand((Hjava_lang_Short*)body[i])->value;
-			}
-			else if (a == javaLangByteClass) {
-				args[j].f = unhand((Hjava_lang_Byte*)body[i])->value;
-			} else {
-				SignalError("java.lang.IllegalArgumentException", "expecting float value");
-			}
+			args[i].f = (*env)->GetFloatField(env, arg, Fvalue);
 			break;
 		case 'D':
-			if (a == javaLangDoubleClass) {
-				args[j].d = unhand((Hjava_lang_Double*)body[i])->value;
-			}
-			else if (a == javaLangFloatClass) {
-				args[j].d = unhand((Hjava_lang_Float*)body[i])->value;
-			}
-			else if (a == javaLangLongClass) {
-				args[j].d = unhand((Hjava_lang_Long*)body[i])->value;
-			}
-			else if (a == javaLangIntegerClass) {
-				args[j].d = unhand((Hjava_lang_Integer*)body[i])->value;
-			}
-			else if (a == javaLangCharacterClass) {
-				args[j].d = unhand((Hjava_lang_Character*)body[i])->value;
-			}
-			else if (a == javaLangShortClass) {
-				args[j].d = unhand((Hjava_lang_Short*)body[i])->value;
-			}
-			else if (a == javaLangByteClass) {
-				args[j].d = unhand((Hjava_lang_Byte*)body[i])->value;
-			} else {
-				SignalError("java.lang.IllegalArgumentException", "expecting double value");
-			}
-			++j;
+			args[i].d = (*env)->GetDoubleField(env, arg, Dvalue);
+			break;
+		case 'J':
+			args[i].j = (*env)->GetLongField(env, arg, Jvalue);
 			break;
-		default:
-			ABORT();
-		} else if (body[i] == 0 ||
-			   instanceof(t, OBJECT_CLASS(body[i]))) {
-			args[j].l = body[i];
-		} else {
-			SignalError("java.lang.IllegalArgumentException", "incompatible object types");
 		}
 	}
 
-	rettype = *METHOD_RET_TYPE(meth);
-
 	/* Select which method to really call, and call it */
 	if (METHOD_IS_STATIC(meth)) {	/* static method */
 
@@ -266,7 +225,7 @@
 			ABORT();
 		}
 	}
-	else if (meth->accflags & ACC_CONSTRUCTOR) { /* a constructor */
+	else if (METHOD_IS_CONSTRUCTOR(meth)) { /* a constructor */
 		/*
 		 * This if applies if we are called from Constructor.newInstance
 		 */
@@ -321,43 +280,35 @@
 		throwException(e);
 		assert(!"Not here");
 	}
-
-	switch (rettype) {
-	case 'V':
-		robj = 0;
-		break;
-	case 'J':
-		robj = execute_java_constructor(0, 0, javaLangLongClass, "(J)V", ret.j);
-		break;
-	case 'F':
-		robj = execute_java_constructor(0, 0, javaLangFloatClass, "(F)V", ret.f);
-		break;
-	case 'D':
-		robj = execute_java_constructor(0, 0, javaLangDoubleClass, "(D)V", ret.d);
-		break;
+	else switch (rettype) {
 	case 'I':
-		robj = execute_java_constructor(0, 0, javaLangIntegerClass, "(I)V", ret.i);
+		return ((*env)->NewObject(env, Iclass, Imeth, ret.i));
+		break;
+	case 'Z':
+		return ((*env)->NewObject(env, Zclass, Zmeth, ret.z));
 		break;
 	case 'S':
-		robj = execute_java_constructor(0, 0, javaLangShortClass, "(S)V", ret.s);
+		return ((*env)->NewObject(env, Sclass, Smeth, ret.s));
 		break;
 	case 'B':
-		robj = execute_java_constructor(0, 0, javaLangByteClass, "(B)V", ret.b);
-		break;
-	case 'Z':
-		robj = execute_java_constructor(0, 0, javaLangBooleanClass, "(Z)V", ret.z);
+		return ((*env)->NewObject(env, Bclass, Bmeth, ret.b));
 		break;
 	case 'C':
-		robj = execute_java_constructor(0, 0, javaLangCharacterClass, "(C)V", ret.c);
+		return ((*env)->NewObject(env, Cclass, Cmeth, ret.c));
+		break;
+	case 'F':
+		return ((*env)->NewObject(env, Fclass, Fmeth, ret.f));
+		break;
+	case 'D':
+		return ((*env)->NewObject(env, Dclass, Dmeth, ret.d));
+		break;
+	case 'J':
+		return ((*env)->NewObject(env, Jclass, Jmeth, ret.j));
 		break;
 	case 'L':
 	case '[':
-		robj = ret.l;
-		break;
-	default:
-		robj = 0;	/* avoid compiler warning */
-		ABORT();
+		return (ret.l);
 	}
 
-	return ((jobject)robj);
+	return (0);
 }
--- /home/topic/kaffe/test/regression/InvTarExcTest.java	Fri Apr 26 02:32:37 2002
+++ test/regression/InvTarExcTest.java	Mon Apr 29 01:22:25 2002
@@ -33,7 +33,7 @@
 	at java.lang.Exception.<init>(Exception.java:24)
 	at InvTarExcTest.f(InvTarExcTest.java:6)
 	at java.lang.reflect.Method.invoke0(Method.java:native)
-	at java.lang.reflect.Method.invoke(Method.java:103)
+	at java.lang.reflect.Method.invoke(Method.java:259)
 	at InvTarExcTest.main(InvTarExcTest.java:13)
 Target is: throwing inner exception
 */
